/* :: ascii-jump project
   :: $Id: frame.c,v 1.1.1.1 2003/02/28 10:05:04 loth Exp $
   
   :: (C)opyright 2003  grzegorz moskal, g.moskal@opengruop.org
   :: license gnu gpl v 2						*/

#define FRAME_C
#include "frame.h"

struct frame* frame_init(char *filename)
{
	FILE *fd = xfopen(filename,"r");
	struct frame *f = xmalloc(sizeof(struct frame));
	int h = 4;
	
	f->h = 0;
	f->w = 0;
	f->next = f->prev = 0;
	f->filename = strdup(filename);
	f->caption = xmalloc(sizeof(char*)*h);

	do {
		if (h == f->h) {
			h *= 2;
			f->caption = xrealloc(f->caption, h*sizeof(char *));
		}
		f->caption[f->h] = read_line(fd);
	} while (f->caption[f->h++]);

	f->h--;
	
	fclose(fd);

	return f;
}

void frame_draw(struct frame *f, int x, int y, int color)
{
	int i = 0;
	
	sl_color(color);

	for (; f->caption[i]; i++) 
		sl_addstrxy(f->caption[i], x, y+i);
}
